- Main Page
- Related Pages
- Modules
- Classes
- Examples

- Class List
- Class Hierarchy
- Class Members

Public Types | Static Public Member Functions

# MDagMessage Class Reference

# OpenMaya - API module for common classes

Search for all occurrences

## Detailed Description

Dependency graph messages.

This class is used to register callbacks for dependency graph messages.

There are 6 types of add callback methods which will add callbacks for the following messages

- Parent Added
- Parent Removed
- Child Added
- Child Removed
- Child Reordered
- Instance Added
- Instance Removed

Methods exist to register callbacks for every time any DAG node is affected as well as methods that work on specific nodes. Each method returns an id which is used to remove the callback.

To remove a callback use MMessage::removeCallback. All callbacks that are registered by a plug-in must be removed by that plug-in when it is unloaded. Failure to do so will result in a fatal error.

NOTE: It is possible to get Parent Added and Child Added messages before the node name has been set. This can happen if the node is newly created. Additionally, the MDagPath string path names passed to the callback may not be set as yet if the node has not been added to the model.

`#include <MDagMessage.h>`

Inheritance diagram for MDagMessage:
[legend]

List of all members.

## Public Types
enum | DagMessage { kInvalidMsg = -1, kParentAdded, kParentRemoved, kChildAdded, kChildRemoved, kChildReordered, kInstanceAdded, kInstanceRemoved, kLast }
| The type of DAG changed messages that have occurred. More...
typedef void(* | MMessageParentChildFunction )(MDagMessage::DagMessage msgType, MDagPath &child, MDagPath &parent, void *clientData)
| Pointer to a callback function which takes an MDagMessage, two MDagPaths and a clientData pointer.
typedef void(* | MWorldMatrixModifiedFunction )(MObject &transformNode, MDagMessage::MatrixModifiedFlags &modified, void *clientData)
| Pointer to world matrix modified callback function.
## Static Public Member Functions
static MCallbackId | addParentAddedCallback (MMessage::MParentChildFunction func, void *clientData=NULL, MStatus *ReturnStatus=NULL)
| This method registers a callback that is called whenever a parent is added in the DAG.
static MCallbackId | addParentAddedDagPathCallback (MDagPath &node, MMessage::MParentChildFunction func, void *clientData=NULL, MStatus *ReturnStatus=NULL)
| This method registers a callback that is called whenever a parent is added to the specified DAG node.
static MCallbackId | addParentRemovedCallback (MMessage::MParentChildFunction func, void *clientData=NULL, MStatus *ReturnStatus=NULL)
| This method registers a callback that is called whenever a parent is removed in the DAG.
static MCallbackId | addParentRemovedDagPathCallback (MDagPath &node, MMessage::MParentChildFunction func, void *clientData=NULL, MStatus *ReturnStatus=NULL)
| This method registers a callback that is called whenever a parent is removed from the specified DAG node.
static MCallbackId | addChildAddedCallback (MMessage::MParentChildFunction func, void *clientData=NULL, MStatus *ReturnStatus=NULL)
| This method registers a callback that is called whenever a child is added in the DAG.
static MCallbackId | addChildAddedDagPathCallback (MDagPath &node, MMessage::MParentChildFunction func, void *clientData=NULL, MStatus *ReturnStatus=NULL)
| This method registers a callback that is called whenever a child is added to the specified DAG node.
static MCallbackId | addChildRemovedCallback (MMessage::MParentChildFunction func, void *clientData=NULL, MStatus *ReturnStatus=NULL)
| This method registers a callback that is called whenever a child is removed in the DAG.
static MCallbackId | addChildRemovedDagPathCallback (MDagPath &node, MMessage::MParentChildFunction func, void *clientData=NULL, MStatus *ReturnStatus=NULL)
| This method registers a callback that is called whenever a child is removed from the specified DAG node.
static MCallbackId | addChildReorderedCallback (MMessage::MParentChildFunction func, void *clientData=NULL, MStatus *ReturnStatus=NULL)
| This method registers a callback that is called whenever a child is reordered in the DAG.
static MCallbackId | addChildReorderedDagPathCallback (MDagPath &node, MMessage::MParentChildFunction func, void *clientData=NULL, MStatus *ReturnStatus=NULL)
| This method registers a callback that is called whenever a child of the specified DAG node is reordered.
static MCallbackId | addDagCallback (DagMessage msgType, MDagMessage::MMessageParentChildFunction func, void *clientData=NULL, MStatus *ReturnStatus=NULL)
| This method is obsolete. This method is not available in Python.
static MCallbackId | addDagDagPathCallback (MDagPath &node, DagMessage msgType, MDagMessage::MMessageParentChildFunction func, void *clientData=NULL, MStatus *ReturnStatus=NULL)
| This method registers a callback that is called for specified a DAG change is made to the specified DAG path.
static MCallbackId | addAllDagChangesCallback (MDagMessage::MMessageParentChildFunction func, void *clientData=NULL, MStatus *ReturnStatus=NULL)
| This method registers a callback that is called whenever any DAG change is made to any DAG node.
static MCallbackId | addAllDagChangesDagPathCallback (MDagPath &node, MDagMessage::MMessageParentChildFunction func, void *clientData=NULL, MStatus *ReturnStatus=NULL)
| This method registers a callback that is called whenever a DAG change is made to the specified DAG path.
static MCallbackId | addInstanceAddedCallback (MMessage::MParentChildFunction func, void *clientData=NULL, MStatus *ReturnStatus=NULL)
| This method registers a callback that is called whenever any node in the DAG is instanced.
static MCallbackId | addInstanceAddedDagPathCallback (MDagPath &node, MMessage::MParentChildFunction func, void *clientData=NULL, MStatus *ReturnStatus=NULL)
| This method registers a callback that is called whenever the specified node is instanced.
static MCallbackId | addInstanceRemovedCallback (MMessage::MParentChildFunction func, void *clientData=NULL, MStatus *ReturnStatus=NULL)
| This method registers a callback that is called whenever an instance of any DAG node is removed or deleted.
static MCallbackId | addInstanceRemovedDagPathCallback (MDagPath &node, MMessage::MParentChildFunction func, void *clientData=NULL, MStatus *ReturnStatus=NULL)
| This method registers a callback that is called whenever an instance of the specified node is removed.
static MCallbackId | addWorldMatrixModifiedCallback (MDagPath &node, MDagMessage::MWorldMatrixModifiedFunction func, void *clientData=NULL, MStatus *ReturnStatus=NULL)
| This method registers a callback that is called when a DAG node's worldMatrix changes.
static const char * | className ()
| Returns the name of this class.
static MCallbackId | addParentAddedCallback (MDagPath &node, MMessage::MParentChildFunction func, void *clientData=NULL, MStatus *ReturnStatus=NULL)
| Obsolete and no script support.
static MCallbackId | addParentRemovedCallback (MDagPath &node, MMessage::MParentChildFunction func, void *clientData=NULL, MStatus *ReturnStatus=NULL)
| Obsolete and no script support.
static MCallbackId | addChildAddedCallback (MDagPath &node, MMessage::MParentChildFunction func, void *clientData=NULL, MStatus *ReturnStatus=NULL)
| obsolete and no script support
static MCallbackId | addChildRemovedCallback (MDagPath &node, MMessage::MParentChildFunction func, void *clientData=NULL, MStatus *ReturnStatus=NULL)
| Obsolete and no script support.
static MCallbackId | addChildReorderedCallback (MDagPath &node, MMessage::MParentChildFunction func, void *clientData=NULL, MStatus *ReturnStatus=NULL)
| Obsolete and no script support.
static MCallbackId | addInstanceAddedCallback (MDagPath &node, MMessage::MParentChildFunction func, void *clientData=NULL, MStatus *ReturnStatus=NULL)
| Obsolete and no script support.
static MCallbackId | addInstanceRemovedCallback (MDagPath &node, MMessage::MParentChildFunction func, void *clientData=NULL, MStatus *ReturnStatus=NULL)
| Obsolete and no script support.
static MCallbackId | addDagCallback (DagMessage msgType, MMessage::MParentChildFunction func, void *clientData=NULL, MStatus *ReturnStatus=NULL)
| Obsolete and no script support.
static MCallbackId | addDagCallback (MDagPath &node, DagMessage msgType, MMessage::MParentChildFunction func, void *clientData=NULL, MStatus *ReturnStatus=NULL)
| Obsolete and no script support. Search for all occurrences
static MCallbackId | addDagCallback (MDagPath &node, DagMessage msgType, MDagMessage::MMessageParentChildFunction func, void *clientData=NULL, MStatus *ReturnStatus=NULL)
| obsolete and no script support
static MCallbackId | addAllDagChangesCallback (MDagPath &node, MDagMessage::MMessageParentChildFunction func, void *clientData=NULL, MStatus *ReturnStatus=NULL)
| Obsolete and no script support. Search for all occurrences

## Member Typedef Documentation

typedef void(* MMessageParentChildFunction)(MDagMessage::DagMessage msgType, MDagPath &child, MDagPath &parent, void *clientData)

Search for all occurrences

Pointer to a callback function which takes an MDagMessage, two MDagPaths and a clientData pointer.

Parameters:

  [in] | msgType | Type of message which caused the function to be called.
  [in,out] | child | First DAG path, usually used to pass the child of a parent/child pair.
  [in,out] | parent | Second DAG path, usually use to pass the parent of a parent/child pair.
  [in,out] | clientData | User-defined data which was supplied when the callback was added.

typedef void(* MWorldMatrixModifiedFunction)(MObject &transformNode, MDagMessage::MatrixModifiedFlags &modified, void *clientData)

Search for all occurrences

Pointer to world matrix modified callback function.

Parameters:

  [in] | transformNode | The node whose transformation has changed.
  [in] | modified | The flag which shows what has changed.
  [in] | clientData | Pointer to user-defined data supplied when the callback was registered.

## Member Enumeration Documentation

enum DagMessage

Search for all occurrences

The type of DAG changed messages that have occurred.

Enumerator:

  kInvalidMsg | an invalid message was used. Search for all occurrences
  kParentAdded | a dummy enum used for looping through the message types Search for all occurrences
  kParentRemoved | a parent was removed from a DAG node Search for all occurrences
  kChildAdded | a child was added to a DAG node Search for all occurrences
  kChildRemoved | a child was removed from a DAG node Search for all occurrences
  kChildReordered | a child of a DAG node was reordered Search for all occurrences
  kInstanceAdded | a DAG node was instanced Search for all occurrences
  kInstanceRemoved | a DAG node instance was removed Search for all occurrences
  kLast | last value of the enum Search for all occurrences

## Member Function Documentation

MCallbackId addParentAddedCallback | ( | MMessage::MParentChildFunction | func,
|  | void * | clientData = `NULL`,
|  | MStatus * | ReturnStatus = `NULL`
| ) |  | `[static]`

Search for all occurrences

This method registers a callback that is called whenever a parent is added in the DAG.

Please see the note in the Description section about this callback.

Parameters:

  [in] | func | the callback function

- child The child involved in the change
- parent The parent involved in the change
- clientData User defined data passed to the callback function

Parameters:

  [in] | clientData | User defined data passed to the callback function
  [out] | ReturnStatus | status code

Returns:
  Identifier used for removing the callback.

Status Codes:
  - MS::kSuccess Operation succeeded
  - MS::kInsufficientMemory No memory available
  - MS::kFailure Error adding callback

MCallbackId addParentAddedDagPathCallback | ( | MDagPath & | node,
|  | MMessage::MParentChildFunction | func,
|  | void * | clientData = `NULL`,
|  | MStatus * | ReturnStatus = `NULL`
| ) |  | `[static]`

Search for all occurrences

This method registers a callback that is called whenever a parent is added to the specified DAG node.

Please see the note in the Description section about this callback.

Parameters:

  [in] | node | The DAG node to register the callback for
  [in] | func | the callback function

- child The child involved in the change
- parent The parent involved in the change
- clientData User defined data passed to the callback function

Parameters:

  [in] | clientData | User defined data passed to the callback function
  [out] | ReturnStatus | status code

Returns:
  Identifier used for removing the callback.

Status Codes:
  - MS::kSuccess Operation succeeded
  - MS::kInsufficientMemory No memory available
  - MS::kFailure Error adding callback

MCallbackId addParentRemovedCallback | ( | MMessage::MParentChildFunction | func,
|  | void * | clientData = `NULL`,
|  | MStatus * | ReturnStatus = `NULL`
| ) |  | `[static]`

Search for all occurrences

This method registers a callback that is called whenever a parent is removed in the DAG.

Parameters:

  [in] | func | the callback function

- child The child involved in the change
- parent The parent involved in the change
- clientData User defined data passed to the callback function

Parameters:

  [in] | clientData | User defined data passed to the callback function
  [out] | ReturnStatus | status code

Returns:
  Identifier used for removing the callback.

Status Codes:
  - MS::kSuccess Operation succeeded
  - MS::kInsufficientMemory No memory available
  - MS::kFailure Error adding callback

MCallbackId addParentRemovedDagPathCallback | ( | MDagPath & | node,
|  | MMessage::MParentChildFunction | func,
|  | void * | clientData = `NULL`,
|  | MStatus * | ReturnStatus = `NULL`
| ) |  | `[static]`

Search for all occurrences

This method registers a callback that is called whenever a parent is removed from the specified DAG node.

Parameters:

  [in] | node | The DAG node to register the callback for
  [in] | func | the callback function

- child The child involved in the change
- parent The parent involved in the change
- clientData User defined data passed to the callback function

Parameters:

  [in] | clientData | User defined data passed to the callback function
  [out] | ReturnStatus | status code

Returns:
  Identifier used for removing the callback.

Status Codes:
  - MS::kSuccess Operation succeeded
  - MS::kInsufficientMemory No memory available
  - MS::kFailure Error adding callback

MCallbackId addChildAddedCallback | ( | MMessage::MParentChildFunction | func,
|  | void * | clientData = `NULL`,
|  | MStatus * | ReturnStatus = `NULL`
| ) |  | `[static]`

Search for all occurrences

This method registers a callback that is called whenever a child is added in the DAG.

Please see the note in the Description section about this callback.

Parameters:

  [in] | func | the callback function

- child The child involved in the change
- parent The parent involved in the change
- clientData User defined data passed to the callback function

Parameters:

  [in] | clientData | User defined data passed to the callback function
  [out] | ReturnStatus | status code

Returns:
  Identifier used for removing the callback.

Status Codes:
  - MS::kSuccess Operation succeeded
  - MS::kInsufficientMemory No memory available
  - MS::kFailure Error adding callback

MCallbackId addChildAddedDagPathCallback | ( | MDagPath & | node,
|  | MMessage::MParentChildFunction | func,
|  | void * | clientData = `NULL`,
|  | MStatus * | ReturnStatus = `NULL`
| ) |  | `[static]`

Search for all occurrences

This method registers a callback that is called whenever a child is added to the specified DAG node.

Please see the note in the Description section about this callback.

Parameters:

  [in] | node | The DAG node to register the callback for
  [in] | func | the callback function

- child The child involved in the change
- parent The parent involved in the change
- clientData User defined data passed to the callback function

Parameters:

  [in] | clientData | User defined data passed to the callback function
  [out] | ReturnStatus | status code

Returns:
  Identifier used for removing the callback.

Status Codes:
  - MS::kSuccess Operation succeeded
  - MS::kInsufficientMemory No memory available
  - MS::kFailure Error adding callback

MCallbackId addChildRemovedCallback | ( | MMessage::MParentChildFunction | func,
|  | void * | clientData = `NULL`,
|  | MStatus * | ReturnStatus = `NULL`
| ) |  | `[static]`

Search for all occurrences

This method registers a callback that is called whenever a child is removed in the DAG.

Parameters:

  [in] | func | the callback function

- child The child involved in the change
- parent The parent involved in the change
- clientData User defined data passed to the callback function

Parameters:

  [in] | clientData | User defined data passed to the callback function
  [out] | ReturnStatus | status code

Returns:
  Identifier used for removing the callback.

Status Codes:
  - MS::kSuccess Operation succeeded
  - MS::kInsufficientMemory No memory available
  - MS::kFailure Error adding callback

MCallbackId addChildRemovedDagPathCallback | ( | MDagPath & | node,
|  | MMessage::MParentChildFunction | func,
|  | void * | clientData = `NULL`,
|  | MStatus * | ReturnStatus = `NULL`
| ) |  | `[static]`

Search for all occurrences

This method registers a callback that is called whenever a child is removed from the specified DAG node.

Parameters:

  [in] | node | The DAG node to register the callback for
  [in] | func | the callback function

- child The child involved in the change
- parent The parent involved in the change
- clientData User defined data passed to the callback function

Parameters:

  [in] | clientData | User defined data passed to the callback function
  [out] | ReturnStatus | status code

Returns:
  Identifier used for removing the callback.

Status Codes:
  - MS::kSuccess Operation succeeded
  - MS::kInsufficientMemory No memory available
  - MS::kFailure Error adding callback

MCallbackId addChildReorderedCallback | ( | MMessage::MParentChildFunction | func,
|  | void * | clientData = `NULL`,
|  | MStatus * | ReturnStatus = `NULL`
| ) |  | `[static]`

Search for all occurrences

This method registers a callback that is called whenever a child is reordered in the DAG.

Parameters:

  [in] | func | the callback function

- child The child involved in the change
- parent The parent involved in the change
- clientData User defined data passed to the callback function

Parameters:

  [in] | clientData | User defined data passed to the callback function
  [out] | ReturnStatus | status code

Returns:
  Identifier used for removing the callback.

Status Codes:
  - MS::kSuccess Operation succeeded
  - MS::kInsufficientMemory No memory available
  - MS::kFailure Error adding callback

MCallbackId addChildReorderedDagPathCallback | ( | MDagPath & | node,
|  | MMessage::MParentChildFunction | func,
|  | void * | clientData = `NULL`,
|  | MStatus * | ReturnStatus = `NULL`
| ) |  | `[static]`

Search for all occurrences

This method registers a callback that is called whenever a child of the specified DAG node is reordered.

Parameters:

  [in] | node | The DAG node to register the callback for
  [in] | func | the callback function

- child The child involved in the change
- parent The parent involved in the change
- clientData User defined data passed to the callback function

Parameters:

  [in] | clientData | User defined data passed to the callback function
  [out] | ReturnStatus | status code

Returns:
  Identifier used for removing the callback.

Status Codes:
  - MS::kSuccess Operation succeeded
  - MS::kInsufficientMemory No memory available
  - MS::kFailure Error adding callback

MCallbackId addDagCallback | ( | DagMessage | msgType,
|  | MDagMessage::MMessageParentChildFunction | func,
|  | void * | clientData = `NULL`,
|  | MStatus * | ReturnStatus = `NULL`
| ) |  | `[static]`

Search for all occurrences

This method is obsolete. This method is not available in Python.

This method registers a callback that is called for specified DAG changes on all nodes.

This method registers a callback that is called whenever a DAG change is made.

Please see the note in the Description section about this callback if Parent Added or Child Added messages are being used.

Parameters:

  [in] | msgType | The type of DAG change to trigger the callback
  [in] | func | the callback function

- child The child involved in the change
- parent The parent involved in the change
- clientData User defined data passed to the callback function

Parameters:

  [in] | clientData | User defined data passed to the callback function
  [out] | ReturnStatus | status code

Returns:
  Identifier used for removing the callback.

Status Codes:
  - MS::kSuccess Operation succeeded
  - MS::kInsufficientMemory No memory available
  - MS::kFailure Error adding callback
  The callback will also receive the DagMessage.

Please see the note in the Description section about this callback if Parent Added or Child Added messages are being used.

Parameters:

  [in] | msgType | The type of DAG change to trigger the callback
  [in] | func | the callback function

- child The child involved in the change
- parent The parent involved in the change
- clientData User defined data passed to the callback function

Parameters:

  [in] | clientData | User defined data passed to the callback function
  [out] | ReturnStatus | status code

Returns:
  Identifier used for removing the callback.

Status Codes:
  - MS::kSuccess Operation succeeded
  - MS::kInsufficientMemory No memory available
  - MS::kFailure Error adding callback

Examples:
  dagMessageCmd.cpp.

MCallbackId addDagDagPathCallback | ( | MDagPath & | node,
|  | DagMessage | msgType,
|  | MDagMessage::MMessageParentChildFunction | func,
|  | void * | clientData = `NULL`,
|  | MStatus * | ReturnStatus = `NULL`
| ) |  | `[static]`

Search for all occurrences

This method registers a callback that is called for specified a DAG change is made to the specified DAG path.

The callback receives the DagMessage as well.

Please see the note in the Description section about this callback if Parent Added or Child Added messages are being used.

Parameters:

  [in] | node | The DAG node to register the callback for.
  [in] | msgType | The type of DAG change to trigger the callback.
  [in] | func | The callback function.

- child The child involved in the change.
- parent The parent involved in the change.
- clientData User defined data passed to the callback function.

Parameters:

  [in] | clientData | User defined data passed to the callback function.
  [out] | ReturnStatus | Status code.

Returns:
  Identifier used for removing the callback.

Status Codes:
  - MS::kSuccess Operation succeeded.
  - MS::kInsufficientMemory No memory available.
  - MS::kFailure Error adding callback.

MCallbackId addAllDagChangesCallback | ( | MDagMessage::MMessageParentChildFunction | func,
|  | void * | clientData = `NULL`,
|  | MStatus * | ReturnStatus = `NULL`
| ) |  | `[static]`

Search for all occurrences

This method registers a callback that is called whenever any DAG change is made to any DAG node.

Please see the note in the Description section about this callback if Parent Added or Child Added messages are being used.

Parameters:

  [in] | func | the callback function

- child The child involved in the change
- parent The parent involved in the change
- clientData User defined data passed to the callback function

Parameters:

  [in] | clientData | User defined data passed to the callback function
  [out] | ReturnStatus | status code

Returns:
  Identifier used for removing the callback.

Status Codes:
  - MS::kSuccess Operation succeeded
  - MS::kInsufficientMemory No memory available
  - MS::kFailure Error adding callback

Examples:
  dagMessageCmd.cpp.

MCallbackId addAllDagChangesDagPathCallback | ( | MDagPath & | node,
|  | MDagMessage::MMessageParentChildFunction | func,
|  | void * | clientData = `NULL`,
|  | MStatus * | ReturnStatus = `NULL`
| ) |  | `[static]`

Search for all occurrences

This method registers a callback that is called whenever a DAG change is made to the specified DAG path.

Parameters:

  [in] | node | The DAG node to register the callback for.
  [in] | func | The callback function.

- child The child involved in the change.
- parent The parent involved in the change.
- clientData User defined data passed to the callback function.

Parameters:

  [in] | clientData | User defined data passed to the callback function.
  [out] | ReturnStatus | Status code.

Returns:
  Identifier used for removing the callback.

Status Codes:
  - MS::kSuccess Operation succeeded.
  - MS::kInsufficientMemory No memory available.
  - MS::kFailure Error adding callback.

MCallbackId addInstanceAddedCallback | ( | MMessage::MParentChildFunction | func,
|  | void * | clientData = `NULL`,
|  | MStatus * | ReturnStatus = `NULL`
| ) |  | `[static]`

Search for all occurrences

This method registers a callback that is called whenever any node in the DAG is instanced.

Parameters:

  [in] | func | the callback function

- child The child involved in the change
- parent The parent involved in the change
- clientData User defined data passed to the callback function

Parameters:

  [in] | clientData | User defined data passed to the callback function
  [out] | ReturnStatus | status code

Returns:
  Identifier used for removing the callback.

Status Codes:
  - MS::kSuccess Operation succeeded
  - MS::kInsufficientMemory No memory available
  - MS::kFailure Error adding callback

Examples:
  instanceCallbackCmd.cpp.

MCallbackId addInstanceAddedDagPathCallback | ( | MDagPath & | node,
|  | MMessage::MParentChildFunction | func,
|  | void * | clientData = `NULL`,
|  | MStatus * | ReturnStatus = `NULL`
| ) |  | `[static]`

Search for all occurrences

This method registers a callback that is called whenever the specified node is instanced.

Parameters:

  [in] | node | The DAG node to register the callback for.
  [in] | func | The callback function.

- child The child involved in the change.
- parent The parent involved in the change.
- clientData User defined data passed to the callback function.

Parameters:

  [in] | clientData | User defined data passed to the callback function.
  [out] | ReturnStatus | Status code.

Returns:
  Identifier used for removing the callback.

Status Codes:
  - MS::kSuccess Operation succeeded.
  - MS::kInsufficientMemory No memory available.
  - MS::kFailure Error adding callback.

MCallbackId addInstanceRemovedCallback | ( | MMessage::MParentChildFunction | func,
|  | void * | clientData = `NULL`,
|  | MStatus * | ReturnStatus = `NULL`
| ) |  | `[static]`

Search for all occurrences

This method registers a callback that is called whenever an instance of any DAG node is removed or deleted.

Parameters:

  [in] | func | the callback function

- child The child involved in the change
- parent The parent involved in the change
- clientData User defined data passed to the callback function

Parameters:

  [in] | clientData | User defined data passed to the callback function
  [out] | ReturnStatus | status code

Returns:
  Identifier used for removing the callback.

Status Codes:
  - MS::kSuccess Operation succeeded
  - MS::kInsufficientMemory No memory available
  - MS::kFailure Error adding callback

Examples:
  instanceCallbackCmd.cpp.

MCallbackId addInstanceRemovedDagPathCallback | ( | MDagPath & | node,
|  | MMessage::MParentChildFunction | func,
|  | void * | clientData = `NULL`,
|  | MStatus * | ReturnStatus = `NULL`
| ) |  | `[static]`

Search for all occurrences

This method registers a callback that is called whenever an instance of the specified node is removed.

Parameters:

  [in] | node | The DAG node to register the callback for.
  [in] | func | The callback function.

- child The child involved in the change
- parent The parent involved in the change.
- clientData User defined data passed to the callback function.

Parameters:

  [in] | clientData | User defined data passed to the callback function.
  [out] | ReturnStatus | Status code.

Returns:
  Identifier used for removing the callback.

Status Codes:
  - MS::kSuccess Operation succeeded.
  - MS::kInsufficientMemory No memory available.
  - MS::kFailure Error adding callback.

MCallbackId addWorldMatrixModifiedCallback | ( | MDagPath & | affectedNode,
|  | MDagMessage::MWorldMatrixModifiedFunction | func,
|  | void * | clientData = `NULL`,
|  | MStatus * | ReturnStatus = `NULL`
| ) |  | `[static]`

Search for all occurrences

This method registers a callback that is called when a DAG node's worldMatrix changes.

Since a node's worldMatrix is affected by the transforms of its ancestors in the DAG, it's possible for there to be two different nodes involved: the "trigger" node, whose transform has changed, and the "affected" node, whose worldMatrix is affected by the change to the trigger.

The trigger node may be the same as the affected node, or it may be one of its ancestors.

The callback is placed on the affected node, but it is the trigger node which is passed to the callback.

If the trigger node's transformation is already dirty (i.e. it has not been evaluated since it was last changed) then the callback will not be triggered. So if the trigger node's transformation is modified multiple times between evaluations, only the first one will result in the callback being called.

Parameters:

  [in] | affectedNode | The DAG node to register the callback for.
  [in] | func | The callback function. triggerNode The node whose transformation changed flag How the trigger node's transformation changed clientData User defined data passed to the callback function.
  [in] | clientData | User defined data passed to the callback function.
  [out] | ReturnStatus | Status code.

Returns:
  Identifier used for removing the callback.

Status Codes:
  - MS::kSuccess Operation succeeded.
  - MS::kInsufficientMemory No memory available.
  - MS::kFailure Error adding callback.

const char * className | ( |  | ) | `[static]`

Search for all occurrences

Returns the name of this class.

Returns:
  The name of this class.

Reimplemented from MMessage.

MCallbackId addParentAddedCallback | ( | MDagPath & | node,
|  | MMessage::MParentChildFunction | func,
|  | void * | clientData = `NULL`,
|  | MStatus * | ReturnStatus = `NULL`
| ) |  | `[static]`

Search for all occurrences

Obsolete and no script support.

This method is obsolete. This method is not available in Python.

Deprecated:
  Use MDagMessage::addParentAddedDagPathCallback instead.

This method registers a callback that is called whenever a parent is added to the specified DAG node.

Parameters:

  [in] | node | The DAG node to register the callback for.
  [in] | func | The callback function.

- child The child involved in the change.
- parent The parent involved in the change.
- clientData User defined data passed to the callback function.

Parameters:

  [in] | clientData | User defined data passed to the callback function
  [out] | ReturnStatus | Status code.

Returns:
  Identifier used for removing the callback.

Status Codes:
  - MS::kSuccess Operation succeeded
  - MS::kInsufficientMemory No memory available
  - MS::kFailure Error adding callback

MCallbackId addParentRemovedCallback | ( | MDagPath & | node,
|  | MMessage::MParentChildFunction | func,
|  | void * | clientData = `NULL`,
|  | MStatus * | ReturnStatus = `NULL`
| ) |  | `[static]`

Search for all occurrences

Obsolete and no script support.

This method is obsolete. This method is not available in Python.

Deprecated:
  Use MDagMessage::addParentRemovedDagPathCallback instead.

This method registers a callback that is called whenever a parent is removed from the specified DAG node.

Parameters:

  [in] | node | The DAG node to register the callback for.
  [in] | func | The callback function.

- child The child involved in the change.
- parent The parent involved in the change.
- clientData User defined data passed to the callback function.

Parameters:

  [in] | clientData | User defined data passed to the callback function
  [out] | ReturnStatus | Status code.

Returns:
  Identifier used for removing the callback.

Status Codes:
  - MS::kSuccess Operation succeeded
  - MS::kInsufficientMemory No memory available
  - MS::kFailure Error adding callback

MCallbackId addChildAddedCallback | ( | MDagPath & | node,
|  | MMessage::MParentChildFunction | func,
|  | void * | clientData = `NULL`,
|  | MStatus * | ReturnStatus = `NULL`
| ) |  | `[static]`

Search for all occurrences

obsolete and no script support

This method is obsolete. This method is not available in Python.

Deprecated:
  Use MDagMessage::addChildAddedDagPathCallback instead.

This method registers a callback that is called whenever a child is added to the specified DAG node.

Please see the note in the Description section about this callback.

Parameters:

  [in] | node | The DAG node to register the callback for.
  [in] | func | The callback function.

- child The child involved in the change.
- parent The parent involved in the change.
- clientData User defined data passed to the callback function.

Parameters:

  [in] | clientData | User defined data passed to the callback function.
  [out] | ReturnStatus | Status code.

Returns:
  Identifier used for removing the callback.

Status Codes:
  - MS::kSuccess Operation succeeded.
  - MS::kInsufficientMemory No memory available.
  - MS::kFailure Error adding callback.

MCallbackId addChildRemovedCallback | ( | MDagPath & | node,
|  | MMessage::MParentChildFunction | func,
|  | void * | clientData = `NULL`,
|  | MStatus * | ReturnStatus = `NULL`
| ) |  | `[static]`

Search for all occurrences

Obsolete and no script support.

This method is obsolete. This method is not available in Python.

Deprecated:
  Use MDagMessage::addChildRemovedDagPathCallback instead.

This method registers a callback that is called whenever a child is removed from the specified DAG node.

Parameters:

  [in] | node | The DAG node to register the callback for.
  [in] | func | The callback function.

- child The child involved in the change.
- parent The parent involved in the change.
- clientData User defined data passed to the callback function.

Parameters:

  [in] | clientData | User defined data passed to the callback function.
  [out] | ReturnStatus | Status code.

Returns:
  Identifier used for removing the callback.

Status Codes:
  - MS::kSuccess Operation succeeded.
  - MS::kInsufficientMemory No memory available.
  - MS::kFailure Error adding callback.

MCallbackId addChildReorderedCallback | ( | MDagPath & | node,
|  | MMessage::MParentChildFunction | func,
|  | void * | clientData = `NULL`,
|  | MStatus * | ReturnStatus = `NULL`
| ) |  | `[static]`

Search for all occurrences

Obsolete and no script support.

This method is obsolete. This method is not available in Python.

Deprecated:
  Use MDagMessage::addChildReorderedDagPathCallback instead.

This method registers a callback that is called whenever a child of the specified DAG node is reordered.

Parameters:

  [in] | node | The DAG node to register the callback for.
  [in] | func | The callback function.

- child The child involved in the change.
- parent The parent involved in the change.
- clientData User defined data passed to the callback function.

Parameters:

  [in] | clientData | User defined data passed to the callback function.
  [out] | ReturnStatus | Status code.

Returns:
  Identifier used for removing the callback.

Status Codes:
  - MS::kSuccess Operation succeeded.
  - MS::kInsufficientMemory No memory available.
  - MS::kFailure Error adding callback.

MCallbackId addInstanceAddedCallback | ( | MDagPath & | node,
|  | MMessage::MParentChildFunction | func,
|  | void * | clientData = `NULL`,
|  | MStatus * | ReturnStatus = `NULL`
| ) |  | `[static]`

Search for all occurrences

Obsolete and no script support.

This method is obsolete. This method is not available in Python.

Deprecated:
  Use MDagMessage::addDagCallback instead.

This method registers a callback that is called whenever the specified node is instanced

Parameters:

  [in] | node | The DAG node to register the callback for.
  [in] | func | The callback function.

- child The child involved in the change.
- parent The parent involved in the change.
- clientData User defined data passed to the callback function.

Parameters:

  [in] | clientData | User defined data passed to the callback function.
  [out] | ReturnStatus | Status code.

Returns:
  Identifier used for removing the callback.

Status Codes:
  - MS::kSuccess Operation succeeded.
  - MS::kInsufficientMemory No memory available.
  - MS::kFailure Error adding callback.

MCallbackId addInstanceRemovedCallback | ( | MDagPath & | node,
|  | MMessage::MParentChildFunction | func,
|  | void * | clientData = `NULL`,
|  | MStatus * | ReturnStatus = `NULL`
| ) |  | `[static]`

Search for all occurrences

Obsolete and no script support.

This method is obsolete. This method is not available in Python.

Deprecated:
  Use MDagMessage::addDagCallback instead.

This method registers a callback that is called whenever an instance of the specified node is removed.

Parameters:

  [in] | node | The DAG node to register the callback for.
  [in] | func | The callback function.

- child The child involved in the change.
- parent The parent involved in the change.
- clientData User defined data passed to the callback function.

Parameters:

  [in] | clientData | User defined data passed to the callback function.
  [out] | ReturnStatus | Status code.

Returns:
  Identifier used for removing the callback.

Status Codes:
  - MS::kSuccess Operation succeeded.
  - MS::kInsufficientMemory No memory available.
  - MS::kFailure Error adding callback.

MCallbackId addDagCallback | ( | MDagPath & | node,
|  | DagMessage | msgType,
|  | MMessage::MParentChildFunction | func,
|  | void * | clientData = `NULL`,
|  | MStatus * | ReturnStatus = `NULL`
| ) |  | `[static]`

Search for all occurrences

Obsolete and no script support.

This method is obsolete. This method is not available in Python.

This method registers a callback that is called whenever a DAG change is made to a specified node.

Please see the note in the Description section about this callback if Parent Added or Child Added messages are being used.

Parameters:

  [in] | node | The DAG node to register the callback for.
  [in] | msgType | The type of DAG change to trigger the callback.
  [in] | func | The callback function.

- child The child involved in the change.
- parent The parent involved in the change.
- clientData User defined data passed to the callback function.

Parameters:

  [in] | clientData | User defined data passed to the callback function.
  [out] | ReturnStatus | Status code.

Returns:
  Identifier used for removing the callback.

Status Codes:
  - MS::kSuccess Operation succeeded.
  - MS::kInsufficientMemory No memory available.
  - MS::kFailure Error adding callback.

Deprecated:
  Use MDagMessage::addDagDagPathCallback instead.

MCallbackId addAllDagChangesCallback | ( | MDagPath & | node,
|  | MDagMessage::MMessageParentChildFunction | func,
|  | void * | clientData = `NULL`,
|  | MStatus * | ReturnStatus = `NULL`
| ) |  | `[static]`

Search for all occurrences

Obsolete and no script support.

This method is obsolete. This method is not available in Python.

Deprecated:
  Use MDagMessage::addAllDagChangesDagPathCallback instead.

This method registers a callback that is called whenever a DAG change is made to the specified DAG path.

Parameters:

  [in] | node | The DAG node to register the callback for.
  [in] | func | the callback function.

- child The child involved in the change.
- parent The parent involved in the change.
- clientData User defined data passed to the callback function.

Parameters:

  [in] | clientData | User defined data passed to the callback function.
  [out] | ReturnStatus | Status code.

Returns:
  Identifier used for removing the callback.

Status Codes:
  - MS::kSuccess Operation succeeded.
  - MS::kInsufficientMemory No memory available.
  - MS::kFailure Error adding callback.

MDagMessage MDagMessage MDagMessage MDagMessage MDagMessage MDagMessage MDagMessage MDagMessage MDagMessage MDagMessage
MDagMessage MDagMessage MDagMessage MDagMessage MDagMessage MDagMessage MDagMessage MDagMessage MDagMessage MDagMessage